/*
*	icalc - complex-expression parser
*
*	Various user-commands for complex-number expression parser.
*
*	(C) Martin W Scott, 1991.
*/
#include <stdio.h>
#include <math.h>
#include "complex.h"
#include "complex.tab.h"

extern int silent;	/* flag for whether output is displayed */

void quiticalc()	/* guess... */
{
	exit(0);
}

void besilent()
{
	silent = 1;
}

void beverbose()
{
	silent = 0;
}

void builtins()
{
 	fprintf(stdout,"builtin functions available:\n");
	printlist(C_BLTIN);
	fprintf(stdout,"special functions available:\n");
	printlist(SFUNC);
}

void userfuncs()
{
	fprintf(stdout,"user-defined functions available:\n");
	printlist(UFUNC);
}

void consts()
{
	fprintf(stdout,"predefined constants available:\n");
	printlist(CONST);
}

void vars()
{
	fprintf(stdout,"user-variables defined:\n");
	printlist(VAR);
}

void help()
{
	fprintf(stdout,"commands available:\n");
	printlist(COMMAND);
}